FAQ Search Today's Posts Mark Forums Read
» Video Reviews

» Linux Archive

Linux-archive is a website aiming to archive linux email lists and to make them easily accessible for linux users/developers.


» Sponsor

» Partners

» Sponsor

Go Back   Linux Archive > Debian > Debian Kernel

 
 
LinkBack Thread Tools
 
Old 11-04-2010, 01:42 AM
Asbjoern Sloth Toennesen
 
Default kbuild, deb-pkg: fix Architecture field when cross compiling

Attempt to guess the correct value of the Architecture control
field, based on the ARCH environment variable. Fallback to letting
deb-gencontrol use the host platform's architecture.

With this patch the following make command:

make ARCH=i386 deb-pkg

will output an i386 Debian package instead of an amd64 one,
when run on amd64 machine.

Signed-off-by: Asbjoern Sloth Toennesen <asbjorn@asbjorn.biz>
---
scripts/package/builddeb | 18 +++++++++++++++++-
1 files changed, 17 insertions(+), 1 deletions(-)

diff --git a/scripts/package/builddeb b/scripts/package/builddeb
index 5f1e2fc..02fd63f 100644
--- a/scripts/package/builddeb
+++ b/scripts/package/builddeb
@@ -25,8 +25,24 @@ create_package() {
chown -R root:root "$pdir"
chmod -R go-w "$pdir"

+ # Attempt to find correct debian architecture
+ local forcearch="" debarch=""
+ case "$ARCH" in
+ x86_64) debarch="amd64" ;;
+ i386|ia64) debarch="$ARCH" ;;
+ *)
+ case "$SUBARCH" in
+ arm) debarch=$(grep -q CONFIG_AEABI=y .config
+ && echo armel || echo arm) ;;
+ esac
+ ;;
+ esac
+ if [ -n "$debarch" ] ; then
+ forcearch="-DArchitecture=$debarch"
+ fi
+
# Create the package
- dpkg-gencontrol -isp -p$pname -P"$pdir"
+ dpkg-gencontrol -isp $forcearch -p$pname -P"$pdir"
dpkg --build "$pdir" ..
}

--
1.7.2.3


--
To UNSUBSCRIBE, email to debian-kernel-REQUEST@lists.debian.org
with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org
Archive: 1288838560-6173-1-git-send-email-asbjorn@asbjorn.biz">http://lists.debian.org/1288838560-6173-1-git-send-email-asbjorn@asbjorn.biz
 
Old 11-04-2010, 02:38 AM
Asbjørn Sloth Tønnesen
 
Default kbuild, deb-pkg: fix Architecture field when cross compiling

On 11/04/2010 02:42 AM, Asbjoern Sloth Toennesen wrote:
> + case "$SUBARCH" in
> + arm) debarch=$(grep -q CONFIG_AEABI=y .config
> + && echo armel || echo arm) ;;
> + esac

Hmm, didn't test the ARM part of that patch properly SUBARCH isn't
available to builddeb. Will reply to this mail with fixed patch.


--
To UNSUBSCRIBE, email to debian-kernel-REQUEST@lists.debian.org
with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org
Archive: 4CD22ACF.1000407@asbjorn.it">http://lists.debian.org/4CD22ACF.1000407@asbjorn.it
 
Old 11-04-2010, 02:44 AM
Asbjoern Sloth Toennesen
 
Default kbuild, deb-pkg: fix Architecture field when cross compiling

Attempt to guess the correct value of the Architecture control
field, based on the ARCH environment variable. Fallback to letting
deb-gencontrol use the host platform's architecture.

With this patch the following make command:

make ARCH=i386 deb-pkg

will output an i386 Debian package instead of an amd64 one,
when run on amd64 machine.

Signed-off-by: Asbjoern Sloth Toennesen <asbjorn@asbjorn.biz>
---
scripts/package/builddeb | 17 ++++++++++++++++-
1 files changed, 16 insertions(+), 1 deletions(-)

diff --git a/scripts/package/builddeb b/scripts/package/builddeb
index 5f1e2fc..43b8826 100644
--- a/scripts/package/builddeb
+++ b/scripts/package/builddeb
@@ -25,8 +25,23 @@ create_package() {
chown -R root:root "$pdir"
chmod -R go-w "$pdir"

+ # Attempt to find the correct Debian architecture
+ local forcearch="" debarch=""
+ case "$ARCH" in
+ i386|ia64)
+ debarch="$ARCH" ;;
+ x86_64)
+ debarch="amd64" ;;
+ *)
+ grep -q CONFIG_ARM=y .config &&
+ debarch=arm$(grep -q CONFIG_AEABI=y .config && echo el)
+ esac
+ if [ -n "$debarch" ] ; then
+ forcearch="-DArchitecture=$debarch"
+ fi
+
# Create the package
- dpkg-gencontrol -isp -p$pname -P"$pdir"
+ dpkg-gencontrol -isp $forcearch -p$pname -P"$pdir"
dpkg --build "$pdir" ..
}

--
1.7.2.3


--
To UNSUBSCRIBE, email to debian-kernel-REQUEST@lists.debian.org
with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org
Archive: 1288842244-6863-1-git-send-email-asbjorn@asbjorn.biz">http://lists.debian.org/1288842244-6863-1-git-send-email-asbjorn@asbjorn.biz
 

Thread Tools




All times are GMT. The time now is 08:16 PM.

VBulletin, Copyright ©2000 - 2014, Jelsoft Enterprises Ltd.
Content Relevant URLs by vBSEO ©2007, Crawlability, Inc.
Copyright ©2007 - 2008, www.linux-archive.org